package org.jeecg.modules.stm.survey.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.survey.entity.SurveyTplItemFile;
import org.jeecg.modules.stm.survey.service.ISurveyTplItemFileService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 文件列表
 * @Author: jeecg-boot
 * @Date:   2023-11-15
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/survey/surveyTplItemFile")
@Slf4j
public class SurveyTplItemFileController extends JeecgController<SurveyTplItemFile, ISurveyTplItemFileService> {
	@Autowired
	private ISurveyTplItemFileService surveyTplItemFileService;
	
	/**
	 * 分页列表查询
	 *
	 * @param surveyTplItemFile
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "文件列表-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<SurveyTplItemFile>> queryPageList(SurveyTplItemFile surveyTplItemFile,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<SurveyTplItemFile> queryWrapper = QueryGenerator.initQueryWrapper(surveyTplItemFile, req.getParameterMap());
		Page<SurveyTplItemFile> page = new Page<SurveyTplItemFile>(pageNo, pageSize);
		IPage<SurveyTplItemFile> pageList = surveyTplItemFileService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param surveyTplItemFile
	 * @return
	 */
	@AutoLog(value = "文件列表-添加")
	  
	@RequiresPermissions("survey:survey_tpl_item_file:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody SurveyTplItemFile surveyTplItemFile) {
		surveyTplItemFileService.save(surveyTplItemFile);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param surveyTplItemFile
	 * @return
	 */
	@AutoLog(value = "文件列表-编辑")
	  
	@RequiresPermissions("survey:survey_tpl_item_file:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody SurveyTplItemFile surveyTplItemFile) {
		surveyTplItemFileService.updateById(surveyTplItemFile);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "文件列表-通过id删除")
	  
	@RequiresPermissions("survey:survey_tpl_item_file:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		surveyTplItemFileService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "文件列表-批量删除")
	  
	@RequiresPermissions("survey:survey_tpl_item_file:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.surveyTplItemFileService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "文件列表-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<SurveyTplItemFile> queryById(@RequestParam(name="id",required=true) String id) {
		SurveyTplItemFile surveyTplItemFile = surveyTplItemFileService.getById(id);
		if(surveyTplItemFile==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(surveyTplItemFile);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param surveyTplItemFile
    */
    @RequiresPermissions("survey:survey_tpl_item_file:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, SurveyTplItemFile surveyTplItemFile) {
        return super.exportXls(request, surveyTplItemFile, SurveyTplItemFile.class, "文件列表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("survey:survey_tpl_item_file:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, SurveyTplItemFile.class);
    }

}
